class Image < JekyllComponent

	def custom_setup
		@resized_image = ResizedImage.new(@variables['path'])
		@variables['srcset'] = srcset
	end

	def srcset
		result = []
		@resized_image.versions.each do | version |
			src = ""
			src << assets_dir
			src << "/"
			src << version['filename']
			src << " #{version['size']}w"
			result << src
		end
		result.join(', ')
	end

	def assets_dir
		local_assets_enabled? ?  local_assets_dir : remote_assets_dir
	end

	def local_assets_enabled?
		if ENV['LOCAL_ASSETS'] == "true"
			return true
		elsif Jekyll.sites.first.config['local_assets_enabled']
			return true
		else
			return false
		end
	end

	def default_remote_assets_dir
		# The name of the folder containing the site without any extensions or
		# domain names (eg bobs.co.uk => bobs)
		name = Jekyll.sites.first.config['source']
		name = File.basename(name)
		name = name.sub!(/(?<=.)\..*/, '')
		return "https://static.hardhatwebsites.co.uk/#{name}"
	end

	def remote_assets_dir
		custom = Jekyll.sites.first.config['remote_assets_dir']
		custom ? custom : default_remote_assets_dir
	end

	def local_assets_dir
		custom = Jekyll.sites.first.config['local_assets_dir']
		custom ? custom : "/assets/static"
	end

	def render(context)
		@path = "image"
		super
	end

	Liquid::Template.register_tag "image", self
end

