class Svg < JekyllComponent

	def defaults
		{
			'path' => '',
			'height' => '100%',
			'width' => '100%',
			'fill' => 'currentColor',
		}
	end

	def custom_setup
		target = Jekyll.sites.first.source
		target += "/"
		target += @variables.dig('path')

		if File.file?(target)
			doc = Nokogiri::HTML::DocumentFragment.parse(File.read(target))
			svg_node = doc.css('svg').first
			svg_node['height'] = @variables['height']
			svg_node['width'] = @variables['width']
			svg_node['fill'] = @variables['fill']
			@variables['svg'] = svg_node.to_s
		else
			raise "SVG file doesn't exist at #{target}"
		end
	end

	def render(context)
		@path = 'svg'
		super
	end

	Liquid::Template.register_tag "svg", self
end

